<?php

/*
 * Frontend Signup Site Clone - Plugin Main Administration Page
 * Plugin URI: http://bigtester.com/
 * Version: 0.1
 * Author: Peidong Hu
 * Author URI: http://bigtester.com/
*/

//For Debugging and Testing Purposes ------------



// ----------------------------------------------

/**
 * Couple of includes for functionality
 *
 * @since 1.2.0
 * @updated 1.2.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
include_once ("frontend-signup-site-clone.php");
include_once ("frontend-signup-site-clone-options.php");
include_once ("frontend-signup-site-clone-newFields.php");
include_once ("frontend-signup-site-clone-regForm.php");


	

/**
 * Loads and displays the Frontend Signup Site Clone administration page
 *
 * @since 1.0.0
 * @updated 1.1.0
 * @access private
 * @author Peidong Hu
 * @website http://bigtester.com
*/

//if(!function_exists('bigtester_fessc_myOptionsSubpanel')){
	function bigtester_fessc_myOptionsSubpanel(){

	global $bigtester_fessc_knownFields, $bigtester_fessc_Options, $bigtester_fessc_registrationFields, 
	$bigtester_fessc_NewFields, $bigtester_fessc_fieldOrder, $wpdb, $table_prefix;
		
		
		if(empty($bigtester_fessc_registrationFields)){
			if(function_exists('bigtester_fessc_updateRegistrationFields')){
				bigtester_fessc_updateRegistrationFields();
			}
		}
				
		// Declaring - Defining Variables
		
		$regFields = '';
		$seperator = '';
		$bigtester_fessc_newFieldKey = '';
		$bigtester_fessc_newField = '';
		$csds_userRegMod_fields_missing = '';
		$csds_userRegMod_fields_missing1 = '';
		$csds_userRegMod_fields_missing2 = '';
		$key = '';
		$key1 = '';
		$key2 = '';
		$value = '';
		$value1 = '';
		$value2 = '';
		$cnt = '';
		$cnt1 = 0;
		$field = '';
		$new_field = '';
		$results2 = array();
		$csds_mainMenuErrors = '';
		$show_logo = '';
		$change_logo_link = '';
		$bigtester_fessc_newLogoURL = '';
		$show_background_image = '';
		$bigtester_fessc_newBackgroundImageURL = '';
		$show_background_color = '';
		$bigtester_fessc_newBackgroundColor = '';
		
		// Updating Arrays from options db
		
		$bigtester_fessc_Options = get_option('bigtester_fessc_Options');
		$bigtester_fesscFields = get_option('bigtester_fesscFields');
					
			// Handles adding fields to registration form
			
			if (isset($_POST['info_update']))
			{
				$bigtester_fessc_knownFields = get_option('bigtester_fessc_knownFields');
				$bigtester_fessc_registrationFields = array();
				$bigtester_fessc_current_user = wp_get_current_user();
					if(current_user_can('activate_plugins')){
						if(!empty($_POST['bigtester_fessc_template_id'])){
							$clone_template_id =  $_POST['bigtester_fessc_template_id'];
							update_option("bigtester_fessc_template_id", $clone_template_id);
						}
						if(!empty($_POST['additionalFields'])){
							$results2 =  $_POST['additionalFields'];
								if(!empty($results2)){
									foreach($results2 as $key => $value){
										if(!empty($bigtester_fessc_knownFields)){
											foreach($bigtester_fessc_knownFields as $key1 => $value1){
												if($value == $key1){
													$bigtester_fessc_registrationFields[$key1] = $value1;
													$bigtester_fessc_registrationFields = $bigtester_fessc_registrationFields;
													update_option("bigtester_fessc_registrationFields", $bigtester_fessc_registrationFields);
												}															
											}
										}
									}
								}else{
									$selected = '';
									$bigtester_fessc_registrationFields = array();
									update_option("bigtester_fessc_registrationFields", $bigtester_fessc_registrationFields);
								}
						}else{
							$selected = '';
							$bigtester_fessc_registrationFields = array();
							update_option("bigtester_fessc_registrationFields", $bigtester_fessc_registrationFields);
						}
						echo '<div id="message" class="updated fade"><p>'. __('Registration Form New Required Field Options and Template Site updated successfully.', 'bigtester_fessc') .'</p></div>';					//Report to the user that the data has been updated successfully
					}else{
						echo '<div id="message" class="updated fade"><p>'. __('You do not have adequate permissions to edit this plugin! Please check with Administrator to get additional permissions.', 'bigtester_fessc') .'</p></div>';
						exit();
					}
					
			// Handles adding new fields to database for user profiles and registration
			
			}elseif (isset($_POST['field_update'])){
			
				// Checking for blank fields
			
				if($_POST['bigtester_fessc_newFieldKey'] == '' || $_POST['bigtester_fessc_newField'] == ''){
					if($_POST['bigtester_fessc_newFieldKey'] == '') {
						$csds_userRegMod_fields_missing1 = " New Field Key ";
					}elseif($_POST['bigtester_fessc_newField'] == ''){
						$csds_userRegMod_fields_missing2 = " New Field Name ";
					}elseif($_POST['bigtester_fessc_newFieldKey'] == '' && $_POST['bigtester_fessc_newField'] == ''){
						$csds_userRegMod_fields_missing1 = " New Field Key ";
						$csds_userRegMod_fields_missing2 = " New Field Name ";
						$seperator = " & ";
					}
					else{
						$seperator = " ";
					}
				$csds_userRegMod_fields_missing = $csds_userRegMod_fields_missing1 . $seperator . $csds_userRegMod_fields_missing2;
				echo '<div id="message" class="updated fade"><p>'. __('Options not updated successfully. Missing following: '.$csds_userRegMod_fields_missing,'bigtester_fessc') .'</p></div>';
				exit();
				}else{
					$results = esc_attr(stripslashes($_POST['bigtester_fessc_newFieldKey']));
					$new_field = esc_attr(stripslashes($_POST['bigtester_fessc_newField']));
					
						// Checking for duplicate field in new fields
					
						if(!empty($bigtester_fessc_NewFields)){
							foreach($bigtester_fessc_NewFields as $key => $field){
								if($key == $results){
									echo '<div id="message" class="updated fade"><p>'. __('Cannot add duplicate fields, '. $results . ' is already included in the extra fields!', 'bigtester_fessc') .'</p></div>';
									$csds_mainMenuErrors = TRUE;
									exit();
								}elseif($field == $new_field){
									echo '<div id="message" class="updated fade"><p>'. __('Cannot add duplicate fields, '. $new_field . ' is already included in the extra fields!', 'bigtester_fessc') .'</p></div>';
									$csds_mainMenuErrors = TRUE;
									exit();
								}else{
									$csds_mainMenuErrors = FALSE;
								}
							}	
						}else{
						
							// Checking for duplicate fields in known fields
						
							foreach($bigtester_fessc_knownFields as $key => $field){
								if($key == $results){
									echo '<div id="message" class="updated fade"><p>'. __('Cannot add duplicate fields, '. $results . ' is already included in the extra fields!', 'bigtester_fessc') .'</p></div>';
									$csds_mainMenuErrors = TRUE;
									exit();
								}elseif($field == $new_field){
									echo '<div id="message" class="updated fade"><p>'. __('Cannot add duplicate fields, '. $new_field . ' is already included in the extra fields!', 'bigtester_fessc') .'</p></div>';
									$csds_mainMenuErrors = TRUE;
									exit();
								}else{
									$csds_mainMenuErrors = FALSE;
								}
							}
						}
						
					// Updating arrays and database options
						
					$csds_current_user = wp_get_current_user();
						if(current_user_can('activate_plugins')){
							if(function_exists('csds_add_field_to_users_meta')){
								csds_add_field_to_users_meta($results);
							}
							$bigtester_fessc_NewFields[$results] = $new_field;
							$bigtester_fesscFields[$results] = $new_field;
							update_option("bigtester_fessc_NewFields", $bigtester_fessc_NewFields);
							update_option("bigtester_fesscFields", $bigtester_fesscFields);
							$bigtester_fessc_NewFields = get_option('bigtester_fessc_NewFields');
							$cnt = count($bigtester_fessc_NewFields);
							$bigtester_fessc_fieldOrder[$results] = $cnt;
							update_option("bigtester_fessc_fieldOrder", $bigtester_fessc_fieldOrder);
							echo '<div id="message" class="updated fade"><p>Add New Fields Options updated successfully! </p></div>';
							// Displaying results of operation, whether successful or in error
							
							}else{
							echo '<div id="message" class="updated fade"><p>'?><?php _e('You do not have adequate permissions to edit this plugin! Please check with Administrator to get additional permissions.', 'bigtester_fessc') .'</p></div>';
							exit();
						}
													
				}
				
			// Handles showing support for plugin
			
			}elseif (isset($_POST['bigtester_fessc_support_submit'])){
				$update = array();
				$update = get_option('bigtester_fessc_Options');
				$update['show_support'] = esc_attr(stripslashes($_POST['bigtester_fessc_support']));
				update_option("bigtester_fessc_Options", $update);
				echo '<div id="message" class="updated fade"><p>'. __('Support Options updated successfully.', 'bigtester_fessc') .'</p></div>'; //Report to the user that the data has been updated successfully
			
			}
		
		// Makes sure that if upgrading, the new known fields are added
			// $bigtester_fessc_dbVersion = get_option('bigtester_fessc_dbVersion');
			// if(($bigtester_fessc_knownFields_count < 7) || ($bigtester_fessc_dbVersion != '1.2.0' )){
				// bigtester_fessc_fill_known_fields();
			// }
			// Makes sure that the field order is updated before showing administration page
			
			
				if(!empty($bigtester_fessc_NewFields)){
					if(empty($bigtester_fessc_fieldOrder)){
						if(function_exists('bigtester_fessc_update_field_order')){
							bigtester_fessc_update_field_order();
						}
					}
				}
				
						
		// Making sure all arrays for page are fully loaded from options before page loads
			
		$bigtester_fessc_getOptions = get_option('bigtester_fessc');
		$bigtester_fesscFields = get_option('bigtester_fesscFields');
		$bigtester_fessc_Options = get_option('bigtester_fessc_Options');

		
		
		//find all the existing zones.
		// check for subdir or subdomain install
		if ( is_multisite() ) {
			$subdomain_install = is_subdomain_install();
		}
		//Normal adminpage display
		// fetch existing blogs
		//$the_blogs = get_blog_list( 1, 'all' ); could this also work? ->later
		$tbl_blogs = $wpdb->base_prefix ."blogs";
		$the_blogs = $wpdb->get_results( "SELECT blog_id, domain, path FROM $tbl_blogs WHERE blog_id <> '1'" );
		
		if (!$subdomain_install) {
			// trim each value in the array from slashes (subdirs)
			function removeslash(&$value) {
				$value = str_replace("/", "", $value);
			}
			for ( $i = 0; $i < sizeof( $the_blogs ); $i++ ) {
				array_walk($the_blogs[$i], 'removeslash');
			}
		}
		
		// fetch existing users
		$tbl_users = $wpdb->base_prefix ."users";
		$the_users = $wpdb->get_results( "SELECT ID, user_login FROM $tbl_users" );
		
		// check for errors
		if(!$the_blogs) {
			$error['blogs'] = "there are no templates to choose from";
		}
		if(!$the_users) {
			$error['users'] = "there are no users, which is impossible..";
		}
		
		// if there are no errors continue
		
		
		if(!empty($bigtester_fesscFields)){
			if(!empty($bigtester_fessc_Options)){

			// Shows Aministration Page 
				
		echo '<div id="wpbody">';
			echo '<div class=wrap>';
				echo '<form method="post" name="bigtester_fessc">';
					echo '<h2>'. __('Frontend Signup Site Clone: Clone Template Site When User Sign Up', 'bigtester_fessc') .'</h2>';
					echo '<div id="poststuff">';
					
						//Form for selecting fields to add to registration form
						
						echo '<div class="stuffbox">';
						echo '<h3>'. __('Add Additional Fields to Registration Form', 'bigtester_fessc') .'</h3>';
							echo '<div class="inside">';
								echo '<p>' . __('By default, Wordpress will only require an email address and username to register an account. Here, you can select additional fields required for registration.', 'bigtester_fessc') .'</p>';
								echo '<p><select name="additionalFields[]" id="csds_userRegMod_Select" size="8" multiple style="height:100px">';
								$bigtester_fesscFields = get_option('bigtester_fesscFields');
								$bigtester_fessc_knownFields = get_option('bigtester_fessc_knownFields');
								$regFields = $bigtester_fesscFields;
								
								if(is_array($regFields)){
									foreach($bigtester_fessc_knownFields as $key1 => $value1){
										if(in_array("$value1",$regFields)){
											$selected = "selected=\"selected\"";
										}else{
											$selected = NULL;
										}
									echo "<option value=\"$key1\" $selected >$value1</option>";
									}
								}else{
									exit();
								}
							
															
								echo '</select></p>';
								echo '<p>'. __('Hold "Ctrl" to select multiple options', 'bigtester_fessc') .'</p>';
								?>
								<input type="button" name="selectNone" class="button-primary" value="<?php _e('Select None', 'bigtester_fessc'); ?>" onClick="document.getElementById('csds_userRegMod_Select').options.selectedIndex=-1;"/>
								
								<?php 
								if(!$error) {
								?>
									<div class="wrap">
									<?php wp_nonce_field('go_do_magic','nonce_field'); ?>
									<input type="hidden" name="bigtester_fessc_hidden" value="Y">
									<?php    echo "<h4>" . __( 'Select the blog which will act as a template for the new sites', 'bigtester_fessc_trdom' ) . "</h4>"; ?>
									<p><?php _e("Select the template site which will be cloned:", 'acswpmu_trdom' ); ?>
									<select name="bigtester_fessc_template_id" id="bigtester_fessc_template_id">
									<?php // loop through blogs and echo them
									$bigtester_fessc_template_id = get_option('bigtester_fessc_template_id');
									if ($subdomain_install) {
										foreach ($the_blogs as $a_blog) {
											if ($bigtester_fessc_template_id == $a_blog->blog_id)
												echo "<option value=\"$a_blog->blog_id\" selected=\"selected\">$a_blog->domain</option>";
											else
												echo "<option value=\"$a_blog->blog_id\">$a_blog->domain</option>";
										}
									} else {
										foreach ($the_blogs as $a_blog) {
											echo "<option value=\"$a_blog->blog_id\">$a_blog->path</option>";
										}
									}
									?>
									</select>
									</p>
									</div>
								
								<div class="submit"><input type="submit" class="button-primary" name="info_update" value="<?php _e('Update Options', 'bigtester_fessc');?>"  /></div>
							</div>
						</div>
							<?php 		
						
						//show support section
						
						echo '<div class="stuffbox">';
						echo '<h3><a href="http://www.bigtester.com" target="_blank">Montreal Prot QA</a></h3>';
							echo '<div class="inside">';
							?><h2><?php _e('Plugin Configuration Help', 'bigtester_fessc');?></h2>
								<ul>
									<li><a href="http://bigtester.com/" target="_blank">Plugin Page & Screenshots</a></li>
								</ul>
								<ul>
										<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
										<input type="hidden" name="cmd" value="_s-xclick">
										<input type="hidden" name="hosted_button_id" value="VLFPQMLSD9MJC">
										<input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
										<img alt="" border="0" src="https://www.paypalobjects.com/en_US/i/scr/pixel.gif" width="1" height="1">
										</form>
								</ul><?php
								
							echo '</div>';
						echo '</div>';
					echo '</div>';   
				echo '</form>';
			echo '</div>';
		echo '</div>';
								}
			}else{
				if(function_exists('bigtester_fessc_DefaultOptions')){
					bigtester_fessc_DefaultOptions();
				}
			}
			 
		}else{
			if(function_exists('bigtester_fessc_fill_known_fields')){
				bigtester_fessc_fill_known_fields();
			}
		}
	}

?>
